<template>
  <InputField
    v-model="data.value"
    autocomplete="email"
    type="text"
    title="Email"
    @blur="toogleErrorsShown(true)"
    @input="tryResetErrors"
  >
    <ErrorMark
      v-if="!!data.value && errorsShown && !!errors"
      :modelValue="errors"
    />
  </InputField>
</template>

<script lang="ts" setup>
import type { Rules } from 'async-validator';
import { useAsyncValidator } from '@vueuse/integrations/useAsyncValidator';
import { InputField } from '~shared/ui';
import ErrorMark from './ErrorMark.vue';
import { useAuthStore } from '~/stores/auth';

const props = defineProps<{
  modelValue: string;
}>();
const emit = defineEmits<{
  (e: 'update:modelValue', elem: string): void;
  (e: 'pass', elem: boolean): void;
}>();
const data = reactive({ value: props.modelValue });
const [errorsShown, toogleErrorsShown] = useToggle(false);
const rules: Rules = {
  value: {
    type: 'email',
    required: true,
  },
};
const { pass, errors: validationErrors } = useAsyncValidator(data, rules);
const store = useAuthStore();
const errors = computed(() =>
  store.errors.has ? store.errors.email : validationErrors.value,
);

watch(data, ({ value }) => emit('update:modelValue', value));
watch(pass, (value) => emit('pass', value));

const tryResetErrors = () => {
  store.tryResetErrors();
  toogleErrorsShown(false);
};
</script>
